#include "Amidon.h"

extern PegBitmap gbinductBitmap;

Amidon::Amidon(PegRect rect, CPMainFrame* frame):CPModuleWindow(rect,0,0,frame)
{
init();
}

int Amidon::init()
{   
   	const WORD wStyle = FF_NONE|TJ_LEFT|AF_TRANSPARENT| TT_COPY;
	const SIGNED margin = 10;
	const SIGNED width=mClient.Width()-2*margin;
    
    PegRect rectangle;
    //rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_BOTTOM);

    PEGCHAR* chrmicro = "\xED\x72"; 
	
    rectangle.Set(50, 82, 115, 95);
   	PegTextButton* bot = new PegTextButton(rectangle, "Calcular!", BOTO, AF_ENABLED|TJ_CENTER);
	AddR(bot);
	
    rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_TOP+40);
 	PegBitmapButton * imatge = new PegBitmapButton(rectangle,&gbinductBitmap,0,AF_TRANSPARENT,TYPE_PROMPT,FALSE);
 	AddR(imatge); 

    PegPrompt* label = new PegPrompt(margin, 50, width, "L("+CPString(chrmicro)+"H):",0,wStyle);
	Lvalue = new CPPegString(margin+40,50,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(Lvalue);
	AddR(label);
	
	rectangle.Set(10, 100, MAINFRAME_RIGHT-10, 185); 
    cList = new PegVertList(rectangle,ID_RESULTS);
    cList->SetScrollMode(WSM_AUTOVSCROLL); 
    AddR(cList);
    
	SetDefaultFocus(Lvalue);
	
	im[0]=13;
	im[1]=16;
	im[2]=24;
	im[3]=18;
	im[4]=18;
	im[5]=4;
	im[6]=11;
	im[7]=11;
	im[8]=14;
	im[9]=11;

	int i=0;


	smat[i] = new CPString("T-12-0"); 	adb[i++] = 30;
	smat[i] = new CPString("T-16-0"); 	adb[i++] = 30;
	smat[i] = new CPString("T-20-0"); 	adb[i++] = 35;
	smat[i] = new CPString("T-25-0"); 	adb[i++] = 45;
	smat[i] = new CPString("T-30-0"); 	adb[i++] = 60;
	smat[i] = new CPString("T-37-0"); 	adb[i++] = 49;
	smat[i] = new CPString("T-44-0"); 	adb[i++] = 65;
	smat[i] = new CPString("T-50-0"); 	adb[i++] = 64;
	smat[i] = new CPString("T-68-0"); 	adb[i++] = 75;
	smat[i] = new CPString("T-80-0"); 	adb[i++] = 85;
	smat[i] = new CPString("T-94-0"); 	adb[i++] = 106;
	smat[i] = new CPString("T-106-0"); 	adb[i++] = 190;
	smat[i] = new CPString("T-130-0"); 	adb[i++] = 150;

	smat[i] = new CPString("T-12-1"); 	adb[i++] = 480;
	smat[i] = new CPString("T-16-1"); 	adb[i++] = 440;
	smat[i] = new CPString("T-20-1"); 	adb[i++] = 520;
	smat[i] = new CPString("T-25-1"); 	adb[i++] = 700;
	smat[i] = new CPString("T-30-1"); 	adb[i++] = 850;
	smat[i] = new CPString("T-37-1"); 	adb[i++] = 800;
	smat[i] = new CPString("T-44-1"); 	adb[i++] = 1050;
	smat[i] = new CPString("T-50-1"); 	adb[i++] = 1000;
	smat[i] = new CPString("T-68-1"); 	adb[i++] = 1150;
	smat[i] = new CPString("T-80-1"); 	adb[i++] = 1150;
	smat[i] = new CPString("T-94-1"); 	adb[i++] = 1600;
	smat[i] = new CPString("T-106-1"); 	adb[i++] = 3250;
	smat[i] = new CPString("T-130-1"); 	adb[i++] = 2000;
	smat[i] = new CPString("T-157-1"); 	adb[i++] = 3200;
	smat[i] = new CPString("T-184-1"); 	adb[i++] = 5000;
	smat[i] = new CPString("T-200-1"); 	adb[i++] = 2500;

	smat[i] = new CPString("T-12-2"); 	adb[i++] = 200;
	smat[i] = new CPString("T-16-2"); 	adb[i++] = 220;
	smat[i] = new CPString("T-20-2"); 	adb[i++] = 250;
	smat[i] = new CPString("T-25-2"); 	adb[i++] = 340;
	smat[i] = new CPString("T-30-2"); 	adb[i++] = 430;
	smat[i] = new CPString("T-37-2"); 	adb[i++] = 400;
	smat[i] = new CPString("T-44-2"); 	adb[i++] = 520;
	smat[i] = new CPString("T-50-2"); 	adb[i++] = 490;
	smat[i] = new CPString("T-68-2"); 	adb[i++] = 570;
	smat[i] = new CPString("T-80-2"); 	adb[i++] = 550;
	smat[i] = new CPString("T-94-2"); 	adb[i++] = 840;
	smat[i] = new CPString("T-106-2"); 	adb[i++] = 1350;
	smat[i] = new CPString("T-130-2"); 	adb[i++] = 1100;
	smat[i] = new CPString("T-157-2"); 	adb[i++] = 1400;
	smat[i] = new CPString("T-184-2"); 	adb[i++] = 2400;
	smat[i] = new CPString("T-200-2"); 	adb[i++] = 1200;
	smat[i] = new CPString("T-200A-2"); 	adb[i++] = 2180;
	smat[i] = new CPString("T-225-2"); 	adb[i++] = 1200;
	smat[i] = new CPString("T-225A-2"); 	adb[i++] = 2150;
	smat[i] = new CPString("T-300-2"); 	adb[i++] = 1140;
	smat[i] = new CPString("T-300A-2"); 	adb[i++] = 2280;
	smat[i] = new CPString("T-400-2"); 	adb[i++] = 1800;
	smat[i] = new CPString("T-400A-2"); 	adb[i++] = 3600;
	smat[i] = new CPString("T-520-2"); 	adb[i++] = 2070;

	smat[i] = new CPString("T-12-3"); 	adb[i++] = 600;
	smat[i] = new CPString("T-16-3"); 	adb[i++] = 610;
	smat[i] = new CPString("T-20-3"); 	adb[i++] = 760;
	smat[i] = new CPString("T-25-3"); 	adb[i++] = 1000;
	smat[i] = new CPString("T-30-3"); 	adb[i++] = 1400;
	smat[i] = new CPString("T-37-3"); 	adb[i++] = 1200;
	smat[i] = new CPString("T-44-3"); 	adb[i++] = 1800;
	smat[i] = new CPString("T-50-3"); 	adb[i++] = 1750;
	smat[i] = new CPString("T-68-3"); 	adb[i++] = 1950;
	smat[i] = new CPString("T-80-3"); 	adb[i++] = 1800;
	smat[i] = new CPString("T-94-3"); 	adb[i++] = 2480;
	smat[i] = new CPString("T-106-3"); 	adb[i++] = 4500;
	smat[i] = new CPString("T-130-3"); 	adb[i++] = 3500;
	smat[i] = new CPString("T-157-3"); 	adb[i++] = 4200;
	smat[i] = new CPString("T-184-3"); 	adb[i++] = 7200;
	smat[i] = new CPString("T-200-3"); 	adb[i++] = 4250;
	smat[i] = new CPString("T-200A-3"); 	adb[i++] = 4600;
	smat[i] = new CPString("T-225-3"); 	adb[i++] = 4250;

	smat[i] = new CPString("T-12-6"); 	adb[i++] = 170;
	smat[i] = new CPString("T-16-6"); 	adb[i++] = 190;
	smat[i] = new CPString("T-20-6"); 	adb[i++] = 220;
	smat[i] = new CPString("T-25-6"); 	adb[i++] = 270;
	smat[i] = new CPString("T-30-6"); 	adb[i++] = 360;
	smat[i] = new CPString("T-37-6"); 	adb[i++] = 300;
	smat[i] = new CPString("T-44-6"); 	adb[i++] = 420;
	smat[i] = new CPString("T-50-6"); 	adb[i++] = 460;
	smat[i] = new CPString("T-68-6"); 	adb[i++] = 470;
	smat[i] = new CPString("T-80-6"); 	adb[i++] = 450;
	smat[i] = new CPString("T-94-6"); 	adb[i++] = 700;
	smat[i] = new CPString("T-106-6"); 	adb[i++] = 1160;
	smat[i] = new CPString("T-130-6"); 	adb[i++] = 960;
	smat[i] = new CPString("T-157-6"); 	adb[i++] = 1150;
	smat[i] = new CPString("T-184-6"); 	adb[i++] = 1950;
	smat[i] = new CPString("T-200-6"); 	adb[i++] = 1000;
	smat[i] = new CPString("T-200A-6"); 	adb[i++] = 1800;
	smat[i] = new CPString("T-225-6"); 	adb[i++] = 1000;

	smat[i] = new CPString("T-25-7"); 	adb[i++] = 290;
	smat[i] = new CPString("T-37-7"); 	adb[i++] = 320;
	smat[i] = new CPString("T-50-7"); 	adb[i++] = 430;
	smat[i] = new CPString("T-68-7"); 	adb[i++] = 520;

	smat[i] = new CPString("T-12-10"); 	adb[i++] = 120;
	smat[i] = new CPString("T-16-10"); 	adb[i++] = 130;
	smat[i] = new CPString("T-20-10"); 	adb[i++] = 160;
	smat[i] = new CPString("T-25-10"); 	adb[i++] = 190;
	smat[i] = new CPString("T-30-10"); 	adb[i++] = 250;
	smat[i] = new CPString("T-37-10"); 	adb[i++] = 250;
	smat[i] = new CPString("T-44-10"); 	adb[i++] = 330;
	smat[i] = new CPString("T-50-10"); 	adb[i++] = 310;
	smat[i] = new CPString("T-68-10"); 	adb[i++] = 320;
	smat[i] = new CPString("T-80-10"); 	adb[i++] = 320;
	smat[i] = new CPString("T-94-10"); 	adb[i++] = 580;

	smat[i] = new CPString("T-12-12"); 	adb[i++] = 75;
	smat[i] = new CPString("T-16-12"); 	adb[i++] = 80;
	smat[i] = new CPString("T-20-12"); 	adb[i++] = 100;
	smat[i] = new CPString("T-25-12"); 	adb[i++] = 120;
	smat[i] = new CPString("T-30-12"); 	adb[i++] = 160;
	smat[i] = new CPString("T-37-12"); 	adb[i++] = 150;
	smat[i] = new CPString("T-44-12"); 	adb[i++] = 185;
	smat[i] = new CPString("T-50-12"); 	adb[i++] = 180;
	smat[i] = new CPString("T-68-12"); 	adb[i++] = 210;
	smat[i] = new CPString("T-80-12"); 	adb[i++] = 220;
	smat[i] = new CPString("T-94-12"); 	adb[i++] = 320;

	smat[i] = new CPString("T-12-15"); 	adb[i++] = 500;
	smat[i] = new CPString("T-16-15"); 	adb[i++] = 550;
	smat[i] = new CPString("T-20-15"); 	adb[i++] = 650;
	smat[i] = new CPString("T-25-15"); 	adb[i++] = 850;
	smat[i] = new CPString("T-30-15"); 	adb[i++] = 930;
	smat[i] = new CPString("T-37-15"); 	adb[i++] = 900;
	smat[i] = new CPString("T-44-15"); 	adb[i++] = 1600;
	smat[i] = new CPString("T-50-15"); 	adb[i++] = 1350;
	smat[i] = new CPString("T-68-15"); 	adb[i++] = 1800;
	smat[i] = new CPString("T-80-15"); 	adb[i++] = 1700;
	smat[i] = new CPString("T-94-15"); 	adb[i++] = 2000;
	smat[i] = new CPString("T-106-15"); 	adb[i++] = 3450;
	smat[i] = new CPString("T-130-15"); 	adb[i++] = 2500;
	smat[i] = new CPString("T-157-15"); 	adb[i++] = 3600;

	smat[i] = new CPString("T-12-17"); 	adb[i++] = 75;
	smat[i] = new CPString("T-16-17"); 	adb[i++] = 80;
	smat[i] = new CPString("T-20-17"); 	adb[i++] = 100;
	smat[i] = new CPString("T-25-17"); 	adb[i++] = 120;
	smat[i] = new CPString("T-30-17"); 	adb[i++] = 160;
	smat[i] = new CPString("T-37-17"); 	adb[i++] = 150;
	smat[i] = new CPString("T-44-17"); 	adb[i++] = 185;
	smat[i] = new CPString("T-50-17"); 	adb[i++] = 180;
	smat[i] = new CPString("T-68-17"); 	adb[i++] = 210;
	smat[i] = new CPString("T-80-17"); 	adb[i++] = 320;
	smat[i] = new CPString("T-90-17"); 	adb[i++] = 320;


    selmat = 0;

 	PegRect ListRect;
    PEGCHAR cTemp[30];
    
    ListRect.Set(40, 67, 150, 117);
    freqs = new PegComboBox(ListRect,ID_DESP);
    
    i=0;    
    strcpy(cTemp, "20 MHz-200 MHz");
    freqs->Add(new PegPrompt(0, 0, cTemp, i++, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY)); 
    strcpy(cTemp, "0.1 MHz-2 MHz");
    freqs->Add(new PegPrompt(0, 0, cTemp, i++, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY)); 
    strcpy(cTemp, "50 MHz-200 MHz");
    freqs->Add(new PegPrompt(0, 0, cTemp, i++, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY)); 
    strcpy(cTemp, "30 MHz-100 MHz");
    freqs->Add(new PegPrompt(0, 0, cTemp, i++, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY)); 
    strcpy(cTemp, "3 MHz-35 MHz");
    freqs->Add(new PegPrompt(0, 0, cTemp, i++, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY)); 
    strcpy(cTemp, "10 MHz-50 MHz");
    freqs->Add(new PegPrompt(0, 0, cTemp, i++, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY)); 
    strcpy(cTemp, "0.05MHz-0.5MHz");
    freqs->Add(new PegPrompt(0, 0, cTemp, i++, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY)); 
    strcpy(cTemp, "2 MHz-30 MHz");
    freqs->Add(new PegPrompt(0, 0, cTemp, i++, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY)); 
    strcpy(cTemp, "0.5 MHz-5 MHz");
    freqs->Add(new PegPrompt(0, 0, cTemp, i++, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY)); 
    strcpy(cTemp, "100MHz-300MHz");
    freqs->Add(new PegPrompt(0, 0, cTemp, i++, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));
          
    freqs->SetSignals(SIGMASK(PSF_LIST_SELECT));
    freqs->SetScrollMode(WSM_AUTOVSCROLL);
    
    AddR(freqs);

 	PegPrompt* label2 = new PegPrompt(margin, 65, width, "freq:",0,wStyle);
	AddR(label2);    
    
	return 0;
}

void Amidon::Draw()
{
	BeginDraw();
	Invalidate(mClient);
	DrawFrame();
	DrawChildren();
	EndDraw();
}

SIGNED Amidon::Message(const PegMessage &Mesg)
{
	switch(Mesg.wType)
	{
		case SIGNAL(BOTO, PSF_CLICKED):
		{
		    CalculaN();
		}
		break;
       case SIGNAL(ID_DESP, PSF_LIST_SELECT):
		{
		    selmat = (short)freqs->GetSelectedIndex();
		}
		break;		
		default:
		return CPModuleWindow::Message(Mesg);
	}
	return 0;
}

WORD Amidon::Dialog(char* title, char* message)
{
	PegRect rr = GetMainFrame()->TopAppRectangle();
	rr.wBottom -= 30;
	rr.wRight -= 10;
	rr.wTop += 10;
	rr.wLeft += 10;
	PegMessageWindow *msg = new PegMessageWindow(rr, title, message, MW_OK, 0,0,0);
	return msg->Execute();
}  

void Amidon::CalculaN(void)
{
    
    cList->Clear();
    
    OBCD aux,aux2;
    int i,j;
    
    i=0;

    for(j=0;j<selmat;j++)
    {
        i += im[j];
    }    
    j = i+im[selmat];
    
    for(;i<j;i++)
    {
        aux = CPExpression(Lvalue->DataGet());
        Cal_longto_OBC((long)adb[i],&aux2);
        Cal_div_OBC(&aux,&aux2);
        ExecuteToOBCD("10",aux2);
        Cal_mul_OBC(&aux,&aux2);
        Cal_sqrt_OBC(&aux);
        ExecuteToOBCD("100",aux2);
        Cal_mul_OBC(&aux,&aux2);
        Cal_cint_OBC(&aux);
        cList->AddToEnd(new PegPrompt(0, 0, (*smat[i])+" -> "+CPString(aux)+" turns", 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));
    }
  
    Draw();
} 
   
extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
return "";
}
